/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vsb.cs.navrat.test;

import cz.vsb.cs.navrat.CzechAccountNumberValidator;
import static org.junit.Assert.*;
import org.junit.Test;

/**
 *
 * @author lumi
 */
public class CzechAccountNumberValidatorTest {

    public CzechAccountNumberValidatorTest() {
    }

    /**
     * Test na zadanou null retezec
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetNull() {
        System.out.println("checkBankovniUcetNull");
        String cislouctu = null;
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na zadanou prazdnou delku retezce
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetEmpty() {
        System.out.println("checkBankovniUcetEmpty");
        String cislouctu = "";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na delku cisla uctu mensi nez 4
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetMinLength() {
        System.out.println("checkBankovniUcetMinLength");
        String cislouctu = "11";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na delku cisla uctu vetsi nez 16
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetMaxLength() {
        System.out.println("checkBankovniUcetMaxLength");
        String cislouctu = "12345673203410257";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na delku cisla prefixu delsi nez 6
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetMaxLengthPrefix() {
        System.out.println("checkBankovniUcetMaxLengthPrefix");
        String cislouctu = "1234567-3203410257";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na zadanou pomlcku, ale bez cisla v prefixu.
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetEmptyPrefix() {
        System.out.println("checkBankovniUceEmptyPrefix");
        String cislouctu = "-3203410257";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na spatne cislo uctu
     */
    @Test(expected = IllegalArgumentException.class)
    public void testCheckBankovniUcetChybne() {
        System.out.println("checkBankovniUcetChybne");
        String cislouctu = "2179-3203410257";
        CzechAccountNumberValidator.checkBankovniUcet(cislouctu);
    }

    /**
     * Test na spravne cislo uctu
     */
    @Test
    public void testCheckBankovniUcetSpravne1() {
        System.out.println("checkBankovniUcetSpravne");
        String cislouctu = "2719-3203410257";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));

        cislouctu = "27193203410257";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));

        cislouctu = "4010951";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));

    }

    /**
     * Test na spravne cislo uctu
     */
    @Test
    public void testCheckBankovniUcetSpravne2() {
        System.out.println("checkBankovniUcetSpravne2");

        String cislouctu = "27193203410257";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));

    }

    /**
     * Test na spravne cislo uctu
     */
    @Test
    public void testCheckBankovniUcetSpravne3() {
        System.out.println("checkBankovniUcetSpravne3");
        String cislouctu = "4010951";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));
    }

    /**
     * Test na spravne cislo uctu
     */
    @Test
    public void testCheckBankovniUcetSpravne4Mezery() {
        System.out.println("checkBankovniUcetSpravne4");
        String cislouctu = "40 10 951";
        assertTrue(CzechAccountNumberValidator.checkBankovniUcet(cislouctu));
    }

}
